{
    Файл является частью библиотеки RubiRobot

    © 2017 Слинкин Д.А.

    Вспомогательные функции библиотеки

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}
{$SMARTLINK ON}
unit uev3func;

{$mode objfpc}

interface
uses unix;
type 
     TAVar=array of variant;
     TAAstring=array of ansistring;
     TAObject=array of tobject;

function arg2int(arg:TVarRec):integer;
function arg2string(arg:TVarRec):string;
function arg2obj(arg:TVarRec):TObject;

//Function StartProcess(const Command:AnsiString):cint;overload;
Function StartProcess(const Command:AnsiString; args:array of AnsiString):cint;overload; //без shell
Procedure StartPipedProcess(const Command1:AnsiString; const args1:array of AnsiString;
                            const Command2:AnsiString; const args2:array of AnsiString; out pid1,pid2:cint);
function istermProcess(childPid:cint):boolean;
procedure killProcess(childPid:cint);

function EVIOCGKEY(len:dword):dword;

procedure push(var arg: TAVar; value: variant);overload;
function pop(var arg: TAVar):variant;overload;
procedure push(var arg: TAObject; value: TObject);overload;
function pop(var arg: TAObject):TObject;overload;
procedure push(var arg: TAAString; value: string);overload;
//procedure pushA(var arg: TAAString; value: ansistring);
function pop(var arg: TAAString):string;overload;

implementation
uses SysUtils, variants, baseunix;

function EVIOCGKEY(len:dword):dword;
begin
      result:= 2 shl (14+8+8) or len shl (8+8) or ord('E') shl 8 or $18;
end;

procedure StartPipedProcess(const Command1: AnsiString;
  const args1: array of AnsiString; const Command2: AnsiString;
  const args2: array of AnsiString;out pid1,pid2:cint);
var
    devnull, ret:cint;
    pipein, pipeout:cint;
  begin { Changes as above }
    //writeln(length(args1),' -- ',length(args2));
    pipein:=0;pipeout:=0;
    assignPipe(pipein, pipeout);
    devnull:=fpopen('/dev/null',O_WrOnly);
    pid1:=fpfork;
    if pid1=0 then // We are in the Child
     begin
      // writeln(pipein,' ',pipeout);
       ret:=fpdup2(devnull,2);
       if ret=-1 then fpexit(15);
       ret:=fpdup2(pipeout,1);
       if ret=-1 then fpexit(7);
       fpclose(pipein);
       fpclose(pipeout);
       fpclose(devnull);
       fpExecL(command1,args1);
       fpExit(127); // was exit(127)!! We must exit the Process, not the function
     end;
    pid2:=fpfork;
    if pid2=0 then // We are in the Child
     begin
     //  writeln(pipein,' ',pipeout);
       ret:=fpdup2(devnull,2);
       if ret=-1 then fpexit(3);
       ret:=fpdup2(pipein,0);
       if ret=-1 then fpexit(1);
       fpclose(pipein);
       fpclose(pipeout);
       fpclose(devnull);
       fpExecL(command2,args2);
       fpExit(127); // was exit(127)!! We must exit the Process, not the function
     end;
    fpclose(pipein);
    fpclose(pipeout);
    fpclose(devnull);
  end;

function istermProcess(childPid:cint):boolean;
 var temp:cint;
begin
  result:=boolean(FpWaitPid(childPid,@temp,WNOHANG));
end;

procedure killProcess(childPid:cint);
begin
  fpKill(childPid,SIGINT);
  fpwaitpid(childPid,nil,0);
end;

procedure push(var arg: TAVar; value: variant);
begin
//  writeln(length(arg),'++',value);
  setlength(arg,length(arg)+1);
  arg[length(arg)-1]:=value;
end;

function pop(var arg: TAVar): variant;
begin
  result:=arg[length(arg)-1];
  setlength(arg,length(arg)-1);
end;


procedure push(var arg: TAAString; value: string);
begin
  setlength(arg,length(arg)+1);
  arg[length(arg)-1]:=value;
end;

function pop(var arg: TAAString): string;
begin
  result:=arg[length(arg)-1];
  setlength(arg,length(arg)-1);
end;


procedure push(var arg: TAObject; value: TObject);
begin
  setlength(arg,length(arg)+1);
  arg[length(arg)-1]:=value;
end;

procedure pushA(var arg: TAAString; value: ansistring);
begin
  setlength(arg,length(arg)+1);
  arg[length(arg)-1]:=value;
end;


function pop(var arg: TAObject): TObject;
begin
  result:=arg[length(arg)-1];
  setlength(arg,length(arg)-1);
end;


  function arg2string(arg:TVarRec):string;
 begin
     case arg.vtype of
       vtinteger : result:=inttostr(arg.vinteger);
       vtInt64 : result:=inttostr(arg.vInt64^);
       vtQWord : result:=inttostr(arg.vQWord^);
       vtboolean : if arg.vboolean then result:='TRUE' else result:='FALSE';
       vtchar    : result:=arg.vchar;
       vtextended: result:=formatFloat('#.##',arg.VExtended^);
       vtString  : result:=arg.VString^;
       vtPChar   : result:=Arg.VPChar;
       vtAnsiString : result:=AnsiString(Arg.VAnsiString);
       vtVariant : result:=varToStr(Arg.VVariant^);
     else
       result:='(???)';
     end;
 end;

  function arg2obj(arg: TVarRec): TObject;
  begin
    result:=arg.VObject;
  end;

{
  function StartProcess(const Command: AnsiString): cint;
  var
     pid   : cint;
      p      : ppchar;
      devnull,ret:cint;
   begin
     if command='' then exit(-1);
     p:=CreateShellArgv(command);
     pid:=fpfork;
     if pid=0 then // We are in the Child
      begin
        devnull:=fpopen('/dev/null',O_WrOnly);
        ret:=fpdup2(devnull,2);
        if ret=-1 then fpexit(15);
        ret:=fpdup2(devnull,1);
        if ret=-1 then fpexit(15);
        fpExecv(p^,p);
        fpExit(127); // was exit(127)!! We must exit the Process, not the function
      end
     else result:=pid;
     FreeShellArgV(p);
   end;
}
    function StartProcess(const Command: AnsiString; args: array of AnsiString
    ): cint;
  var
     pid   : cint;
     devnull,ret:cint;
   begin { Changes as above }
     if command='' then exit(-1);
     pid:=fpfork;
     if pid=0 then // We are in the Child
      begin
        devnull:=fpopen('/dev/null',O_WrOnly);
        ret:=fpdup2(devnull,2);
        if ret=-1 then fpexit(15);
        ret:=fpdup2(devnull,1);
        if ret=-1 then fpexit(15);
        fpExecL(command,args);
        fpExit(127); // was exit(127)!! We must exit the Process, not the function
      end
     else result:=pid;
   end;




function arg2int(arg:TVarRec):integer;
 begin
   result:=0;
   try
     case arg.vtype of
       vtinteger : result:=arg.vinteger;
       vtInt64 : result:=arg.vInt64^;
       vtQWord : result:=arg.vQWord^;
       vtboolean : result:=ord(arg.vboolean);
       vtchar    : result:=strtoint(arg.vchar);
       vtextended: result:=round(arg.VExtended^);
       vtString  : result:=strtoint(arg.VString^);
       vtPChar   : result:=strtoint(Arg.VPChar);
       vtAnsiString : result:=strtoint(Ansistring(Arg.VAnsiString));
       vtVariant : result:=Arg.VVariant^;
     end;
   except
   end;
 end;

end.

